﻿
using System;
using System.Collections.Generic;
using System.Linq;
using Wisej.Web;

namespace TestDefaultValueNeeded
{
    public partial class Window1 : Form
    {
        List<Profession> professions = new List<Profession> {
            new Profession { ID = 1, Name="Developer" },
            new Profession { ID = 2, Name="DBA" },
            new Profession { ID = 3, Name="Technician" }
        };

        List<Person> persons = new List<Person> {
            new Person { ID = 1, Lastname = "Prinias", Profession = 2, DOB = new DateTime(2000, 3, 12) },
            new Person { ID = 2, Lastname = "Pavlov", Profession = 2, DOB = new DateTime(2010, 6, 12) },
            new Person { ID = 3, Lastname = "Smirnov", Profession = 3, DOB = new DateTime(1978, 7, 18) },
            new Person { ID = 4, Lastname = "Putin", Profession = 1, DOB = new DateTime(1965, 3, 23) }
        };

        List<Person> fewPersons, copyPersons; 

        public Window1()
        {
            InitializeComponent();

            dataGridView1.AutoGenerateColumns = false;
            dataGridView1.AllowUserToAddRows = true;

            var cID = new DataGridViewTextBoxColumn();
            cID.HeaderText = "ID";
            cID.DataPropertyName = "ID";
            dataGridView1.Columns.Add(cID);

            var cLastName = new DataGridViewTextBoxColumn();
            cLastName.HeaderText = "Lastname";
            cLastName.DataPropertyName = "Lastname";
            dataGridView1.Columns.Add(cLastName);

            var cProfession = new DataGridViewComboBoxColumn();
            cProfession.Name = "cProfession";
            cProfession.HeaderText = "Profession";
            cProfession.DataPropertyName = "Profession";
            cProfession.ValueMember = "ID";
            cProfession.DisplayMember = "Name";
            cProfession.DataSource = professions;
            dataGridView1.Columns.Add(cProfession);

            var cDOB = new DataGridViewDateTimePickerColumn();
            cDOB.Name = "cDOB";
            cDOB.Width = 140;
            cDOB.HeaderText = "DOB";
            cDOB.DataPropertyName = "DOB";
            dataGridView1.Columns.Add(cDOB);

            dataGridView1.DefaultValuesNeeded += dataGridView1_DefaultValuesNeeded;



            dataGridView3.AutoGenerateColumns = false;
            dataGridView3.AllowUserToAddRows = true;

            var cID3 = new DataGridViewTextBoxColumn();
            cID3.HeaderText = "ID";
            cID3.DataPropertyName = "ID";
            dataGridView3.Columns.Add(cID3);

            var cLastName3 = new DataGridViewTextBoxColumn();
            cLastName3.HeaderText = "Lastname";
            cLastName3.DataPropertyName = "Lastname";
            dataGridView3.Columns.Add(cLastName3);

            var cProfession3 = new DataGridViewComboBoxColumn();
            cProfession3.Name = "cProfession3";
            cProfession3.HeaderText = "Profession";
            cProfession3.DataPropertyName = "Profession";
            cProfession3.ValueMember = "ID";
            cProfession3.DisplayMember = "Name";
            cProfession3.DataSource = professions;
            dataGridView3.Columns.Add(cProfession3);

            var cDOB3 = new DataGridViewDateTimePickerColumn();
            cDOB3.Width = 140;
            cDOB3.Name = "cDOB3";
            cDOB3.HeaderText = "DOB";
            cDOB3.DataPropertyName = "DOB";
            dataGridView3.Columns.Add(cDOB3);

            //dataGridView1.DefaultValuesNeeded += dataGridView1_DefaultValuesNeeded;



            dataGridView2.AutoGenerateColumns = false;
            dataGridView2.AllowUserToAddRows = true;

            var cID2 = new DataGridViewTextBoxColumn();
            cID2.HeaderText = "ID";
            cID2.DataPropertyName = "ID";
            dataGridView2.Columns.Add(cID2);

            var cLastName2 = new DataGridViewTextBoxColumn();
            cLastName2.HeaderText = "Lastname";
            cLastName2.DataPropertyName = "Lastname";
            dataGridView2.Columns.Add(cLastName2);

            var cProfession2 = new DataGridViewComboBoxColumn();
            cProfession2.Name = "cProfession2";
            cProfession2.HeaderText = "Profession";
            cProfession2.DataPropertyName = "Profession";
            cProfession2.ValueMember = "ID";
            cProfession2.DisplayMember = "Name";
            cProfession2.DataSource = professions;
            dataGridView2.Columns.Add(cProfession2);

            var cDOB2 = new DataGridViewDateTimePickerColumn();
            cDOB2.Width = 140;
            cDOB2.Name = "cDOB2";
            cDOB2.HeaderText = "DOB";
            cDOB2.DataPropertyName = "DOB";
            dataGridView2.Columns.Add(cDOB2);

            dataGridView2.DefaultValuesNeeded += dataGridView2_DefaultValuesNeeded;

        }

        private void dataGridView1_DefaultValuesNeeded(object sender, DataGridViewRowEventArgs e)
        {
            e.Row.Cells["cProfession"].Value = 1;
            e.Row.Cells["cDOB"].Value = DateTime.Today;
        }

        private void dataGridView2_DefaultValuesNeeded(object sender, DataGridViewRowEventArgs e)
        {
            e.Row.Cells["cProfession2"].Value = 1;
            e.Row.Cells["cDOB2"].Value = DateTime.Today;
        }

        private void Window1_Load(object sender, EventArgs e)
        {
            copyPersons = new List<Person>();
            foreach (var p in persons)
            {
                copyPersons.Add((Person)p.Clone());
            }
            fewPersons = persons.Where(n => n.ID > 10).ToList();

            dataGridView1.DataSource = persons;
            dataGridView3.DataSource = copyPersons;
            dataGridView2.DataSource = fewPersons;
        }


    }

    public class Person : ICloneable
    {
        public int ID { get; set; }
        public string Lastname { get; set; }
        public int Profession { get; set; }
        public DateTime DOB { get; set; }

        public object Clone()
        {
            return new Person { ID = this.ID, Lastname = this.Lastname, Profession = this.Profession, DOB = this.DOB };
        }
    }

    public class Profession
    {
        public int ID { get; set; }
        public string Name { get; set; }
    }
}
